using System;
using System.Collections.Generic;
using System.Text;
using Zcu.Mve.Core;

namespace Zcu.Mve.Elementals
{
    class DummyLevelDescreaser:Module
    {
        public DummyLevelDescreaser()
        {
            AddInPort("Input", typeof(IDataObject), true, false);
            this.PortConnected += new PortConnectingEventHandler(DummyLevelDescreaser_PortConnecting);
            this.PortDisconnected += new PortDisconnectingEventHandler(DummyLevelDescreaser_PortDisconnecting);
        }

        void DummyLevelDescreaser_PortDisconnecting(object source, InPort portTo, out bool allowed)
        {
            allowed = true;
            this.RemoveOutPort("Output");
        }

        void DummyLevelDescreaser_PortConnecting(object source, OutPort portFrom, InPort portTo, out bool allowed)
        {
            allowed = true;
            this.AddOutPort("Output", portFrom.PortType);
        }

        public override void Execute()
        {
            UpdateInput("Input");
            SetOutput("Output", GetInput("Input"), IsDataSame("Input"));
        }
    }
}
