using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Zcu.Mve.Core;


namespace Zcu.Mve.Elementals
{
	/// <summary>
	/// Setting window for XmlSaverSetup.
	/// </summary>
	public class XmlSaverSetup : Zcu.Mve.Core.ModuleSetup
	{
    private System.Windows.Forms.TextBox textBox1;
    private System.Windows.Forms.Button button1;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
    private XmlSaver saver;

    /// <summary>
    /// Calls required method by the Windows.Forms Form Designer
    /// </summary>
    /// <param name="saver"></param>
    public XmlSaverSetup(XmlSaver saver)
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			this.saver = saver;

      textBox1.Text = saver.FileName;
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.textBox1 = new System.Windows.Forms.TextBox();
      this.button1 = new System.Windows.Forms.Button();
      this.SuspendLayout();
      // 
      // textBox1
      // 
      this.textBox1.Location = new System.Drawing.Point(1, 2);
      this.textBox1.Name = "textBox1";
      this.textBox1.Size = new System.Drawing.Size(198, 20);
      this.textBox1.TabIndex = 0;
      this.textBox1.Text = "textBox1";
      this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
      // 
      // button1
      // 
      this.button1.Location = new System.Drawing.Point(207, 2);
      this.button1.Name = "button1";
      this.button1.Size = new System.Drawing.Size(32, 20);
      this.button1.TabIndex = 1;
      this.button1.Text = "...";
      this.button1.Click += new System.EventHandler(this.button1_Click);
      // 
      // XmlLoaderSetup
      // 
      this.Controls.Add(this.button1);
      this.Controls.Add(this.textBox1);
      this.Name = "XmlLoaderSetup";
      this.Size = new System.Drawing.Size(240, 24);
      this.ResumeLayout(false);

    }
		#endregion
	
    /// <summary>
    /// On OK button was clcked.
    /// </summary>
    /// <returns></returns>
    public override bool OnOkClick()
    {
      saver.FileName = textBox1.Text.Trim();

      return true;
    }


    /// <summary>
    /// On "three dots" button has been clicked.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void button1_Click(object sender, System.EventArgs e)
    {
      SaveFileDialog fd = new SaveFileDialog();
      fd.DefaultExt = "xml";
      fd.FileName = textBox1.Text;
      fd.ShowDialog();
      textBox1.Text = fd.FileName;
    }

    private void textBox1_TextChanged(object sender, System.EventArgs e)
    {
    
    }
  }
}
