using System;
using System.Collections.Generic;
using System.Text;
using Zcu.Mve.Core;
using Zcu.Mve.Visualization;

namespace Examples
{
    class UnstrGrid2TriangleMesh:Module
    {
        TriangleMesh result = null;

        public UnstrGrid2TriangleMesh()
        {
            AddInPort("UnstrGrid", typeof(UnstrGrid));
            AddOutPort("TriangleMesh", typeof(TriangleMesh));
        }

        public override void Execute()
        {
            if ((!IsAllDataSame()) || (result == null))
            {
                UnstrGrid input = (UnstrGrid)this.GetInput("UnstrGrid");
                result = new TriangleMesh();
                result.Points = input.Points;
                foreach(string cellsName in input.GetCellIds())
                {
                    UniformDataArray cells = input.GetCells(cellsName);
                    if (cells.ElemType == typeof(Triangle))
                    {
                        result.AddCells(cellsName, cells);
                        foreach (string attrName in input.GetCellAttrsIds(cellsName))
                        {
                            result.AddCellAttrs(cellsName, attrName, input.GetCellAttrs(cellsName, attrName));
                        }
                    }
                }

                foreach (string attrName in input.GetPointAttrsIds())
                {
                    result.AddPointAttrs(attrName, input.GetPointAttrs(attrName));
                }
                SetOutput("TriangleMesh", result, false);
            }
            else
            {
                SetOutput("TriangleMesh", result, true);
            }
        }
    }
}
