using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using Zcu.Mve.Visualization;
using Zcu.Mve.Core;
using Zcu.Mve.Numerics;

namespace Zcu.Mve.Testing
{
	public class ConvSourceSetup : Zcu.Mve.Core.ModuleSetup
	{
		private System.ComponentModel.IContainer components = null;
    private System.Windows.Forms.TextBox textBox00;
    private System.Windows.Forms.TextBox textBox01;
    private System.Windows.Forms.TextBox textBox02;
    private System.Windows.Forms.TextBox textBox12;
    private System.Windows.Forms.TextBox textBox11;
    private System.Windows.Forms.TextBox textBox10;
    private System.Windows.Forms.TextBox textBox22;
    private System.Windows.Forms.TextBox textBox21;
    private System.Windows.Forms.TextBox textBox20;
    private ConvSource convSrc;

    public ConvSourceSetup(ConvSource convSrc)
    {
      InitializeComponent();

      this.convSrc = convSrc;

      if (convSrc.mask.Width != 3 || convSrc.mask.Height != 3)
      {
        throw new MveException(this, "Mask in ConvSource is not 3x3");
      }
     
      double val;
      
      val = ((Scalar) convSrc.mask[0, 0]).Value;
      textBox00.Text = val.ToString("0.00", Globals.nfi);

      val = ((Scalar) convSrc.mask[0, 1]).Value;
      textBox10.Text = val.ToString("0.00", Globals.nfi);

      val = ((Scalar) convSrc.mask[0, 2]).Value;
      textBox20.Text = val.ToString("0.00", Globals.nfi);

      val = ((Scalar) convSrc.mask[1, 0]).Value;
      textBox01.Text = val.ToString("0.00", Globals.nfi);

      val = ((Scalar) convSrc.mask[1, 1]).Value;
      textBox11.Text = val.ToString("0.00", Globals.nfi);

      val = ((Scalar) convSrc.mask[1, 2]).Value;
      textBox21.Text = val.ToString("0.00", Globals.nfi);

      val = ((Scalar) convSrc.mask[2, 0]).Value;
      textBox02.Text = val.ToString("0.00", Globals.nfi);

      val = ((Scalar) convSrc.mask[2, 1]).Value;
      textBox12.Text = val.ToString("0.00", Globals.nfi);

      val = ((Scalar) convSrc.mask[2, 2]).Value;
      textBox22.Text = val.ToString("0.00", Globals.nfi);

    }
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.textBox00 = new System.Windows.Forms.TextBox();
      this.textBox01 = new System.Windows.Forms.TextBox();
      this.textBox02 = new System.Windows.Forms.TextBox();
      this.textBox12 = new System.Windows.Forms.TextBox();
      this.textBox11 = new System.Windows.Forms.TextBox();
      this.textBox10 = new System.Windows.Forms.TextBox();
      this.textBox22 = new System.Windows.Forms.TextBox();
      this.textBox21 = new System.Windows.Forms.TextBox();
      this.textBox20 = new System.Windows.Forms.TextBox();
      this.SuspendLayout();
      // 
      // textBox00
      // 
      this.textBox00.Location = new System.Drawing.Point(8, 8);
      this.textBox00.Name = "textBox00";
      this.textBox00.Size = new System.Drawing.Size(56, 20);
      this.textBox00.TabIndex = 0;
      this.textBox00.Text = "textBox1";
      // 
      // textBox01
      // 
      this.textBox01.Location = new System.Drawing.Point(72, 8);
      this.textBox01.Name = "textBox01";
      this.textBox01.Size = new System.Drawing.Size(56, 20);
      this.textBox01.TabIndex = 1;
      this.textBox01.Text = "textBox2";
      // 
      // textBox02
      // 
      this.textBox02.Location = new System.Drawing.Point(136, 8);
      this.textBox02.Name = "textBox02";
      this.textBox02.Size = new System.Drawing.Size(56, 20);
      this.textBox02.TabIndex = 2;
      this.textBox02.Text = "textBox3";
      // 
      // textBox12
      // 
      this.textBox12.Location = new System.Drawing.Point(136, 32);
      this.textBox12.Name = "textBox12";
      this.textBox12.Size = new System.Drawing.Size(56, 20);
      this.textBox12.TabIndex = 5;
      this.textBox12.Text = "textBox4";
      // 
      // textBox11
      // 
      this.textBox11.Location = new System.Drawing.Point(72, 32);
      this.textBox11.Name = "textBox11";
      this.textBox11.Size = new System.Drawing.Size(56, 20);
      this.textBox11.TabIndex = 4;
      this.textBox11.Text = "textBox5";
      // 
      // textBox10
      // 
      this.textBox10.Location = new System.Drawing.Point(8, 32);
      this.textBox10.Name = "textBox10";
      this.textBox10.Size = new System.Drawing.Size(56, 20);
      this.textBox10.TabIndex = 3;
      this.textBox10.Text = "textBox6";
      // 
      // textBox22
      // 
      this.textBox22.Location = new System.Drawing.Point(136, 56);
      this.textBox22.Name = "textBox22";
      this.textBox22.Size = new System.Drawing.Size(56, 20);
      this.textBox22.TabIndex = 8;
      this.textBox22.Text = "textBox7";
      // 
      // textBox21
      // 
      this.textBox21.Location = new System.Drawing.Point(72, 56);
      this.textBox21.Name = "textBox21";
      this.textBox21.Size = new System.Drawing.Size(56, 20);
      this.textBox21.TabIndex = 7;
      this.textBox21.Text = "textBox8";
      // 
      // textBox20
      // 
      this.textBox20.Location = new System.Drawing.Point(8, 56);
      this.textBox20.Name = "textBox20";
      this.textBox20.Size = new System.Drawing.Size(56, 20);
      this.textBox20.TabIndex = 6;
      this.textBox20.Text = "textBox9";
      // 
      // ConvSourceSetup
      // 
      this.Controls.Add(this.textBox22);
      this.Controls.Add(this.textBox21);
      this.Controls.Add(this.textBox20);
      this.Controls.Add(this.textBox12);
      this.Controls.Add(this.textBox11);
      this.Controls.Add(this.textBox10);
      this.Controls.Add(this.textBox02);
      this.Controls.Add(this.textBox01);
      this.Controls.Add(this.textBox00);
      this.Name = "ConvSourceSetup";
      this.Size = new System.Drawing.Size(200, 80);
      this.ResumeLayout(false);

    }
		#endregion
	
    public override bool OnOkClick()
    {
      UniformDataArray2D tmpMask = new UniformDataArray2D(typeof(Scalar), 3, 3);
      double val;
      double sum = 0;

      sum += val = Double.Parse(textBox00.Text.Trim(), Globals.nfi);
      tmpMask[0, 0] = (Scalar)val;

      sum += val = Double.Parse(textBox10.Text.Trim(), Globals.nfi);
      tmpMask[0, 1] = (Scalar)val;

      sum += val = Double.Parse(textBox20.Text.Trim(), Globals.nfi);
      tmpMask[0, 2] = (Scalar)val;

      sum += val = Double.Parse(textBox01.Text.Trim(), Globals.nfi);
      tmpMask[1, 0] = (Scalar)val;

      sum += val = Double.Parse(textBox11.Text.Trim(), Globals.nfi);
      tmpMask[1, 1] = (Scalar)val;

      sum += val = Double.Parse(textBox21.Text.Trim(), Globals.nfi);
      tmpMask[1, 2] = (Scalar)val;

      sum += val = Double.Parse(textBox02.Text.Trim(), Globals.nfi);
      tmpMask[2, 0] = (Scalar)val;

      sum += val = Double.Parse(textBox12.Text.Trim(), Globals.nfi);
      tmpMask[2, 1] = (Scalar)val;

      sum += val = Double.Parse(textBox22.Text.Trim(), Globals.nfi);
      tmpMask[2, 2] = (Scalar)val;

      if (sum != 0)
      {
        for (int i = 0; i < 3; i++)
          for (int j = 0; j < 3; j++)
            tmpMask[i, j] = new Scalar(((Scalar)tmpMask[i, j]).Value / sum);
      }
      
      convSrc.mask = tmpMask;

      return true;
    }
  
    public override bool OnStornoClick()
    {
      // TODO:  Add ConvSourceSetup.OnStornoClick implementation
      return base.OnStornoClick ();
    }
  }
}

