using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Zcu.Mve.Core;

namespace Zcu.Mve.Testing
{
	/// <summary>
	/// Summary description for ElevationSetup.
	/// </summary>
	public class ElevationSetup : ModuleSetup
	{
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
    private System.Windows.Forms.GroupBox groupBox1;
    private System.Windows.Forms.RadioButton radioButton1;
    private System.Windows.Forms.RadioButton radioButton2;
    private System.Windows.Forms.RadioButton radioButton3;
    private ElevationFilter elevation;

		public ElevationSetup(ElevationFilter elevation)
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
      this.elevation = elevation;
      switch (elevation.axis)
      {
        case 0:
          radioButton1.Checked = true;
          break;
        case 1:
          radioButton2.Checked = true;
          break;
        case 2:
          radioButton3.Checked = true;
          break;
      }
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.groupBox1 = new System.Windows.Forms.GroupBox();
      this.radioButton3 = new System.Windows.Forms.RadioButton();
      this.radioButton2 = new System.Windows.Forms.RadioButton();
      this.radioButton1 = new System.Windows.Forms.RadioButton();
      this.groupBox1.SuspendLayout();
      this.SuspendLayout();
      // 
      // groupBox1
      // 
      this.groupBox1.Controls.Add(this.radioButton3);
      this.groupBox1.Controls.Add(this.radioButton2);
      this.groupBox1.Controls.Add(this.radioButton1);
      this.groupBox1.Location = new System.Drawing.Point(0, 0);
      this.groupBox1.Name = "groupBox1";
      this.groupBox1.Size = new System.Drawing.Size(72, 96);
      this.groupBox1.TabIndex = 0;
      this.groupBox1.TabStop = false;
      this.groupBox1.Text = "axis";
      // 
      // radioButton3
      // 
      this.radioButton3.Location = new System.Drawing.Point(16, 72);
      this.radioButton3.Name = "radioButton3";
      this.radioButton3.Size = new System.Drawing.Size(40, 16);
      this.radioButton3.TabIndex = 2;
      this.radioButton3.Text = "Z";
      this.radioButton3.Click += new System.EventHandler(this.radioButton3_Click);
      // 
      // radioButton2
      // 
      this.radioButton2.Location = new System.Drawing.Point(16, 48);
      this.radioButton2.Name = "radioButton2";
      this.radioButton2.Size = new System.Drawing.Size(40, 16);
      this.radioButton2.TabIndex = 1;
      this.radioButton2.Text = "Y";
      this.radioButton2.Click += new System.EventHandler(this.radioButton2_Click);
      // 
      // radioButton1
      // 
      this.radioButton1.Checked = true;
      this.radioButton1.Location = new System.Drawing.Point(16, 24);
      this.radioButton1.Name = "radioButton1";
      this.radioButton1.Size = new System.Drawing.Size(32, 16);
      this.radioButton1.TabIndex = 0;
      this.radioButton1.TabStop = true;
      this.radioButton1.Text = "X";
      this.radioButton1.Click += new System.EventHandler(this.radioButton1_Click);
      // 
      // ElevationSetup
      // 
      this.Controls.Add(this.groupBox1);
      this.Name = "ElevationSetup";
      this.Size = new System.Drawing.Size(72, 96);
      this.groupBox1.ResumeLayout(false);
      this.ResumeLayout(false);

    }
		#endregion
	
    public override bool OnOkClick()
    {
      return true;
    }

    private void radioButton1_Click(object sender, System.EventArgs e)
    {
      this.elevation.axis = 0;
      this.elevation.Execute();
    }
    private void radioButton2_Click(object sender, System.EventArgs e)
    {
      this.elevation.axis = 1;
      this.elevation.Execute();
    }
    private void radioButton3_Click(object sender, System.EventArgs e)
    {
      this.elevation.axis = 2;
      this.elevation.Execute();
    }

  }
}
