using System;
using Zcu.Mve.Numerics;

namespace Zcu.Mve.Testing
{
	/// <summary>
	/// 
	/// </summary>
	public class Pendulum : Zcu.Mve.Core.Module
	{
    private PendulumPanel panel;
    internal double pendulumPosition;

		public Pendulum()
		{
      this.SimulationStarted += new SimulationStartedEventHandler(SimStart);
      this.SimulationEnding += new SimulationEndingEventHandler(SimEnd);
      AddInPort("pendulumPosition", typeof(Scalar));
      panel = new PendulumPanel(this);
		}
	
    public override void Execute()
    {
      pendulumPosition = ((Scalar)GetInput("pendulumPosition")).Value;
      
      if (panel.IsDisposed == false)
      {
        panel.Refresh();
      }

      System.Threading.Thread.Sleep(25);
    }

    public void SimStart(object source)
    {
      if (panel.IsDisposed)
      {
        panel = new PendulumPanel(this);
      }
      panel.Show();
    }

    public void SimEnd(object source)
    {
      panel.Dispose();
      /*
      if (panel.IsDisposed)
      {
        panel = new PositionRendererPanel(this);
      }
      panel.Show();
      */
      Console.WriteLine("Pendulum: simulation finished.");
    }
  }
}
