using System;
using Zcu.Mve.Core;
using Zcu.Mve.Visualization;
using Zcu.Mve.Numerics;
using System.Drawing;

namespace Zcu.Mve.Testing
{
  /// <summary>
  /// 
  /// </summary>
  [ModuleInfo("Milan Frank", "Test source")]
  [PortInfo("array", "data array")]
  public class TestSource : Zcu.Mve.Core.Module
  {
    internal RectilinearGrid2D val;

	  Color c;

	  public Color C
	  {
		  get { return (c); }
		  set { c = value; }
	  }
    

    public TestSource()
    {
      double [] height = new double [5] {1, 2, 3, 4, 5};
      double [] width = new double [4] {1, 2, 3, 4};

      val = new RectilinearGrid2D(height, width);
      width[1] = 10;

      UniformDataArray2D colors = new UniformDataArray2D(typeof(ColorRGBA), 4, 3);
      colors[0, 1] = new ColorRGBA(0.2f, 0.2f, 0.4f);
      val.AddCellAttrs("color", colors);

      AddOutPort("value", val.GetType());
    }
	
    public override void Execute()
    {
      SetOutput("value", val);
    }
  }
}
