using System;
using Zcu.Mve.Core;
using Zcu.Mve.Visualization;
using Zcu.Mve.Numerics;

namespace Zcu.Mve.Testing
{
	/// <summary>
	/// Summary description for UniformArray2RegGrid.
	/// </summary>
	public class UniformArray2RegGrid:Module
	{
		RegGrid2D output = null;
		string attrName = "values";

        private bool paramsChanged = true;

		public string AttrName
		{
			get
			{
				return(attrName);
			}
			set
			{
				if (value!="")
				{
					attrName = value;
					paramsChanged = true;
				}
				else
				{
					throw new MveException(this, "Output attribute name cannot be an empty string.");
				}
			}
		}

		public UniformArray2RegGrid()
		{
			AddInPort("Input array",typeof(UniformDataArray2D));
			AddOutPort("Output grid",typeof(RegGrid2D));
		}

		public override void Execute()
		{
			if ((!IsDataSame("Input array"))||(output == null)||(paramsChanged))
			{
				UniformDataArray2D input = (UniformDataArray2D)GetInput("Input array");
				output = new RegGrid2D(input.Height,input.Width);
				output.AddCellAttrs(attrName,input);
				SetOutput("Output grid",output);
				paramsChanged = false;
			}
			else
			{
				SetOutput("Output grid",output,true);
			}
		}
	}
}
