using Zcu.Mve.Core;
using Zcu.Mve.Numerics;
using Zcu.Mve.Visualization;

using System.Drawing;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using System.Xml;
using System.Diagnostics;
using System.Globalization;
using System.ComponentModel;
using System.Drawing.Design;
using System;

namespace Zcu.Mve.UnstrGridRendering
{
    [ModuleInfo("Frantisek Novak", "Stereo wall render using Direct3D interface.", IconName = "SceneRenderer.ico")]
    [PortInfo("inScene", "Representation of Scene. Scene is a composition of SceneObjects and Lights.")]
    [PortInfo("inCamera", "Camera settings.")]
    class StereoWallRendererModule : SceneRendererModule
    {
        public StereoWallRendererModule() : base()
        {
            ;
        }

        public override void Execute()
        {
            InitializeInput();

            if (!UseInternalCamera)
                camera = (Camera)GetInput("inCamera");
            else
                camera = new Camera();

            renderer = new StereoWallRenderer(scene, uda, camera, rendererParameters);

            // check for input data structures updates
            renderer.OnIdle += new OnIdleEventHandler(UpdateInput);

            //base.HookPickerToOutputPort();

            renderer.Run();
        }

        /// <summary>
        /// Creates new instance of module and copy all necessary member variables.
        /// This method is used by MapEditor in Copy/Paste process.
        /// Without overriding it returns implicit instance of current module.
        /// </summary>
        public override Module DeepCopy()
        {
            StereoWallRendererModule swr = (StereoWallRendererModule) base.DeepCopy();

            swr.rendererParameters = (RendererParameters)this.rendererParameters.DeepCopy();

            return swr;
        }
    }
}
