using System;
using System.Text;
using System.Threading;
using System.Diagnostics;
using System.Windows.Forms;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.IO;

using Zcu.Mve.Core;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace Zcu.Mve.UnstrGridRendering
{
    /// <summary>
    /// calss used for snapshots
    /// </summary>
    public class TextureSaver
    {
        #region fields
        private bool renderTotexture, snapShot;
        private long lastSaved;
        private float framelenght;
        static int id;
        #endregion

        #region properties

        /// <summary>
        /// save frequenci
        /// </summary>
        public int Framelenght
        {
            set { framelenght = 1.0f/value; }
        }

        /// <summary>
        /// true if snapshop should be taken
        /// </summary>
        public bool SnapShot
        {
            get { return snapShot; }
            set { snapShot = value; }
        }

        /// <summary>
        /// on/off texture save
        /// </summary>
        public bool RenderTotexture
        {
            get { return renderTotexture; }
            set { renderTotexture = value; }
        }

        #endregion

        public TextureSaver()
        {
            renderTotexture = false;
            snapShot = false;
            lastSaved = 0;

            id = 0;
        }

        /// <summary>
        /// true if image should be saved
        /// </summary>
        /// <returns></returns>
        public bool toSave()
        {
            return (renderTotexture || snapShot);
        }

        /// <summary>
        /// save surface on disc - !!! PATH has to be checked
        /// </summary>
        /// <param name="surface"></param>
        public void SaveToFile(Surface surface, String path, Device device)
        {
            if (Environment.TickCount - lastSaved > framelenght)
            {
                id++;

                SurfaceLoader.Save(path + id.ToString("000") + ".png", ImageFileFormat.Png, surface);
                lastSaved = Environment.TickCount;
                snapShot = false;
            } 
        }
        
        /// <summary>
        /// save texture on disc - !!! PATH has to be checked
        /// </summary>
        /// <param name="texture"></param>
        public void SaveToFile(Texture texture, String path, Device device)
        {
            if (Environment.TickCount - lastSaved > framelenght)
            {
                id++;

                TextureLoader.Save(path + id + ".png", ImageFileFormat.Png, texture);
                lastSaved = Environment.TickCount;
                snapShot = false;
            } 
        }
    }
}
