using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Zcu.Mve.UnstrGridRendering.Legend
{
    class VolumeCutLegend : BaseLegend
    {
        ColorMappingFunction mapfce;

        internal ColorMappingFunction MapFunction
        {
            get { return mapfce; }
            set { mapfce = value; }
        }

        public VolumeCutLegend(Point location, Size size) : base(new System.Drawing.Rectangle(location, size))
        {
            ;
        }

        protected override void Draw(System.Drawing.Graphics g)
        {
            System.Drawing.Pen p = new System.Drawing.Pen(Color.Black);

            g.DrawRectangle(p, new System.Drawing.Rectangle(0, 0, _rect.Width - 1, _rect.Height - 1));
            p.Dispose();

            g.FillRectangle(System.Drawing.Brushes.White, new System.Drawing.Rectangle(1, 1, _rect.Width - 2, _rect.Height - 2));

            p.Dispose();

            p = new System.Drawing.Pen(Color.Black);

            for (int i = 10; i < _rect.Height - 10; i++)
            {
                p = new System.Drawing.Pen(MapFunction.GetColor(((_rect.Height - 20) - (i - 10)) / (float)(_rect.Height - 20)));
                g.DrawLine(p, new Point(35, i), new Point(_rect.Width - 10, i));
            }

            System.Drawing.Font f = new System.Drawing.Font("Arial", 8.0f);

            g.DrawString("Max", f, System.Drawing.Brushes.Black, new System.Drawing.PointF(7, 12));
            g.DrawString("Min", f, System.Drawing.Brushes.Black, new System.Drawing.PointF(7, _rect.Height - 26));

            p.Dispose();
            f.Dispose();
        }
    }
}
