using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Zcu.Mve.Visualization.Processing
{
    /// <summary>
    /// Class with data types of seznam and bod used by EditablePalette and PaletteGUI.
    /// </summary>
    public class seznam //own data type, it consists of other own data type bod. It is bidirectional connected list.
    {
        bod first;
        bod last;

        public seznam(bod first, bod last)//for every point in seznam point on predecessor and succesor
        {
            this.first = first;
            this.last = last;
        }

        public bod Select(int x, int y, int epsilon)//x pos, y pos, epsilon (range around point tfor drawing
        {
            bod pom = first;
            bod left = first;

            while (pom != null)
            {
                if (Math.Abs(pom.x - x) < epsilon)
                {
                    return pom;
                }
                else if (pom.x < x)
                {
                    left = pom;
                }
                else break;


                pom = pom.right;
            }
            float pomocna = 1.0f / (left.right.x - left.x);


            bod n = new bod(x, y, Color.FromArgb(255, (int)(pomocna * (left.right.x - x) * left.color.R + pomocna * (x - left.x) * left.right.color.R), (int)(pomocna * (left.right.x - x) * left.color.G + pomocna * (x - left.x) * left.right.color.G), (int)(pomocna * (left.right.x - x) * left.color.B + pomocna * (x - left.x) * left.right.color.B)), left, left.right);
            left.right.left = n;
            left.right = n;

            return n;
        }

        public bod First
        {
            get
            {
                return first;
            }
        }
    }

    public class bod //own data type for every control point(CP) in palette
    {
        public int x;//x position
        public int y;//y position
        public Color color;//color of CP
        public bod left, right;//its predecessor, its succesor

        public bod(int x, int y, Color color, bod left, bod right)
        {
            this.x = x;
            this.y = y;
            this.color = color;
            this.left = left;
            this.right = right;
        }
    }
}
