using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using Zcu.Mve.Core;
using Zcu.Mve.Visualization;
using Zcu.Mve.Numerics;

namespace Zcu.Mve.Visualization.Processing
{
    /// <summary>
    /// Ancester for all glyphs, providing data structures for its descendant and static method for 
    /// adding glyphs to unstrGrid according to input positions and attributes
    /// </summary>
    public class Glyph3D
    {
        /// <summary>
        /// Points of the glyph
        /// </summary>
        protected List<Point3D> glyphPoints = new List<Point3D>();
        /// <summary>
        /// Points of the glyph
        /// </summary>
        public List<Point3D> GlyphPoints
        {
            get { return glyphPoints; }
            set { glyphPoints = value; }
        }
        /// <summary>
        ///  Cells of one glyph
        /// </summary>
        protected List<Triangle> glyphCells = new List<Triangle>(); 
        /// <summary>
        /// Cells of one glyph
        /// </summary>
        public List<Triangle> GlyphCells
        {
            get { return glyphCells; }
            set { glyphCells = value; }
        }
        
        /// <summary>
        /// Indexes already use in random mode
        /// </summary>
        protected bool[] usedIndexes;// cells of one glyph
        /// <summary>
        /// Indexes already use in random mode
        /// </summary>
        public bool[] UsedIndexes
        {
            get { return usedIndexes; }
            set { usedIndexes = value; }
        }
        
    }
}
