using System;
using System.Drawing;
using System.Windows.Forms;

namespace Zcu.Mve.Visualization.Savers
{
	/// <summary>
	/// Summary description for SaverTriSetup.
	/// </summary>
	public class SaverTriSetup : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button buttonOK;
		private System.Windows.Forms.CheckBox chbTriangles;
		private System.Windows.Forms.CheckBox chbTriangleNormals;
		private System.Windows.Forms.CheckBox chbTriangleNeighbors;
		private System.Windows.Forms.CheckBox chbVerticesNormals;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private bool[] flags = new bool[4];

		public SaverTriSetup()
		{
			this.flags[0] = this.flags[1] = this.flags[2] = this.flags[3] = true;

			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.chbTriangles = new System.Windows.Forms.CheckBox();
			this.chbTriangleNormals = new System.Windows.Forms.CheckBox();
			this.chbTriangleNeighbors = new System.Windows.Forms.CheckBox();
			this.chbVerticesNormals = new System.Windows.Forms.CheckBox();
			this.buttonOK = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 112);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(256, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Checked attributes will be saved (if exist in mesh).";
			// 
			// chbTriangles
			// 
			this.chbTriangles.Checked = true;
			this.chbTriangles.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chbTriangles.Location = new System.Drawing.Point(8, 8);
			this.chbTriangles.Name = "chbTriangles";
			this.chbTriangles.TabIndex = 1;
			this.chbTriangles.Text = "Triangles";
			// 
			// chbTriangleNormals
			// 
			this.chbTriangleNormals.Checked = true;
			this.chbTriangleNormals.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chbTriangleNormals.Location = new System.Drawing.Point(8, 32);
			this.chbTriangleNormals.Name = "chbTriangleNormals";
			this.chbTriangleNormals.Size = new System.Drawing.Size(128, 24);
			this.chbTriangleNormals.TabIndex = 2;
			this.chbTriangleNormals.Text = "Triangles\' Normals";
			// 
			// chbTriangleNeighbors
			// 
			this.chbTriangleNeighbors.Checked = true;
			this.chbTriangleNeighbors.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chbTriangleNeighbors.Location = new System.Drawing.Point(8, 56);
			this.chbTriangleNeighbors.Name = "chbTriangleNeighbors";
			this.chbTriangleNeighbors.Size = new System.Drawing.Size(128, 24);
			this.chbTriangleNeighbors.TabIndex = 3;
			this.chbTriangleNeighbors.Text = "Triangles\' Neighbors";
			// 
			// chbVerticesNormals
			// 
			this.chbVerticesNormals.Checked = true;
			this.chbVerticesNormals.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chbVerticesNormals.Location = new System.Drawing.Point(8, 80);
			this.chbVerticesNormals.Name = "chbVerticesNormals";
			this.chbVerticesNormals.Size = new System.Drawing.Size(128, 24);
			this.chbVerticesNormals.TabIndex = 4;
			this.chbVerticesNormals.Text = "Vertices\' Normals";
			// 
			// buttonOK
			// 
			this.buttonOK.Location = new System.Drawing.Point(176, 8);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.TabIndex = 5;
			this.buttonOK.Text = "OK";
			this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
			// 
			// SaverTriSetup
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(258, 136);
			this.Controls.Add(this.buttonOK);
			this.Controls.Add(this.chbVerticesNormals);
			this.Controls.Add(this.chbTriangleNeighbors);
			this.Controls.Add(this.chbTriangleNormals);
			this.Controls.Add(this.chbTriangles);
			this.Controls.Add(this.label1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "SaverTriSetup";
			this.Text = "SaverTriSetup";
			this.ResumeLayout(false);

		}
		#endregion

		private void buttonOK_Click(object sender, System.EventArgs e)
		{
			flags[0] = this.chbTriangles.Checked;
			flags[1] = this.chbTriangleNormals.Checked;
			flags[2] = this.chbTriangleNeighbors.Checked;
			flags[3] = this.chbVerticesNormals.Checked;

			this.Close();
		}

		public bool[] GetFlags()
		{
			return this.flags;
		}
	}
}
