﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Zcu.Mve.Visualization.Processing
{
    class HistogramForm : Form
    {
        Bitmap bmp;

        public HistogramForm(Bitmap bmp)
        {
            this.Text = "Histogram";

            this.bmp = bmp;
            this.ClientSize = new Size(bmp.Width, bmp.Height);
            this.FormBorderStyle = FormBorderStyle.FixedSingle;
            this.MaximizeBox = false;          
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            g.DrawImage(bmp, 0, 0, bmp.Width, bmp.Height);
            base.OnPaint(e);
        }

        protected override void OnKeyDown(KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Escape)
            {
                this.Dispose();
                this.Close();
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            this.SetStyle(ControlStyles.OptimizedDoubleBuffer | ControlStyles.UserPaint | ControlStyles.AllPaintingInWmPaint, true);
            this.UpdateStyles();
        }

        private void InitializeComponent()
        {
            this.SuspendLayout();
            
            this.ClientSize = new System.Drawing.Size(292, 266);
            this.Name = "HistogramForm";
            this.ResumeLayout(false);

        }
    }
}