//using System;
//using System.IO;
//using System.Text;
//using System.Diagnostics;
//using System.Collections.Generic;
//using System.ComponentModel;
//using System.Windows.Forms.Design;

//using Zcu.Mve.Core;
//using Zcu.Mve.Numerics;
//using Zcu.Mve.Strings;


//namespace Zcu.Mve.Visualization.Loaders
//{
//    class FileNameEditorVOL : FileNameEditor
//    {
//        protected override void InitializeDialog(System.Windows.Forms.OpenFileDialog openFileDialog)
//        {
//            openFileDialog.Filter = "VOL files (*.vol)|*.vol|All files (*.*)|*.*";
//        }
//    }

//    /// <summary>
//    /// Module load volume data into RegGridND structure. Data are load from .vol file.
//    /// For successfull data reading is necessary .vif which should be in the same directory and name. 
//    /// </summary>
//    [ModuleInfo("Novk Frantiek, Ji Zapletal", "Module load volume data from .vol file format.", IconName = "Default.ico", Category = "Gsvd")]
//    [PortInfo("Out", "RegGridND")]
//    public class VolLoader : Zcu.Mve.Core.Module
//    {
//        /// <summary>
//        /// Volume data file.
//        /// </summary>
//        private string volFileName = string.Empty;

//        /// <summary>
//        /// Volume data file description.
//        /// </summary>
//        private string vifFileName = string.Empty;

//        private bool paramsChanged = true;
//        private string pointAttributName = "Values";

//        private Mve.Visualization.RegGridND grid3D = null;

//        /// <summary>
//        /// Create out port.
//        /// </summary>
//        public VolLoader()
//        {
//            AddOutPort("Out", typeof(Mve.Visualization.RegGridND));
//            AddInPort("FileName", typeof(MveString), false);
//        }

//        /// <summary>
//        /// Entry point of module. Call method for reading data and sets data on out port.
//        /// </summary>
//        public override void Execute()
//        {
//            if (!IsAllDataSame() || paramsChanged)
//            {
//                if (GetInput("FileName") != null)
//                    volFileName = (MveString)GetInput("FileName");

//                if (System.IO.File.Exists(volFileName))
//                {
//                    Zcu.Mve.Visualization.Processing.IsoSurfaceExtractor.GCClean();

//                    LoadData();

//                    SetOutput("Out", grid3D);
//                }
//                else
//                    throw new FileNotFoundException(string.Format("File {0} not exists. File name cannot be set to an empty string!", volFileName));
//            }
//            else
//                SetOutput("Out", grid3D, true);
//        }

//        /// <summary>
//        /// Loading vol. data.
//        /// </summary>
//        private void LoadData()
//        {
//            if (volFileName.EndsWith(".vol") || volFileName.EndsWith(".VOL"))
//            {
//                vifFileName = volFileName.ToLower().Replace(".vol", ".vif");

//                if (System.IO.File.Exists(vifFileName))
//                {
//                    int ticks = Environment.TickCount;
//                    StreamReader sr = new StreamReader(vifFileName, Encoding.ASCII);
//                    // load data description from .vif file
//                    Vif vif = new Vif(sr.ReadToEnd(), vifFileName);

//                    ProgressInfoChangedEventHandler bar = new ProgressInfoChangedEventHandler(UpdateProgress);

//                    FileStream fs = new FileStream(volFileName, FileMode.Open, FileAccess.Read, FileShare.None);
//                    BinaryReader br = new BinaryReader(fs);
//                    // load volume data
//                    Vol vol = new Vol(br, vif, bar);

//                    br.Close();
//                    fs.Close();
//                    sr.Close();

//                    double[] mins = new double[] { 0, 0, 0 };
//                    double[] maxs = new double[] { vif.Distortion.X, vif.Distortion.Y, vif.Distortion.Z };
//                    grid3D = new Zcu.Mve.Visualization.RegGridND(mins, maxs, (int)(vif.Resolution.X - 1), (int)(vif.Resolution.Y - 1), (int)(vif.Resolution.Z - 1));
//                    grid3D.AddPointAttrs(pointAttributName, vol.Data);
//                    vol.Data = null;

//                    grid3D.UserTags.Add("Source", vif.Source);
//                    grid3D.UserTags.Add("Caption", vif.Caption);
//                    grid3D.UserTags.Add("Min", vol.Min);
//                    grid3D.UserTags.Add("Max", vol.Max);
//                    grid3D.UserTags.Add("Position", vif.Position);
//                    grid3D.UserTags.Add("Rotation", vif.Rotation);

//                    FileInfo fi = new FileInfo(volFileName);
//                    System.Diagnostics.Debug.WriteLine(string.Format("File {0} loading time: {1} ms", fi.Name, Environment.TickCount - ticks));

//                    Zcu.Mve.Visualization.Processing.IsoSurfaceExtractor.GCClean();

//                    paramsChanged = false;
//                }
//                else
//                    throw new FileNotFoundException(string.Format("File \"{0}\" not found. Vif file is contain description of .vol file ", vifFileName));
//            }
//            else
//                throw new FileNotFoundException(string.Format("Bad file \"{0}\" format, file should be .vol format.", volFileName));
//        }

//        /// <summary>
//        /// Change progress bar value.
//        /// </summary>
//        private void UpdateProgress(object sender, double percent)
//        {
//            ProgressInfo(percent);
//        }

//        #region Properties

//        /// <summary>
//        /// File to load data from. Should be in the .obj format. The property has no effect when there's a connection at the Filename port
//        /// </summary>
//        [Editor(typeof(FileNameEditorVOL), typeof(System.Drawing.Design.UITypeEditor))]
//        [Description("File to load data from. Should be in the .vol format.")]
//        public string FileName
//        {
//            get { return (volFileName); }
//            set
//            {
//                if (value != "")
//                {
//                    volFileName = value;
//                    paramsChanged = true;
//                }
//                else
//                {
//                    throw new MveException(this, "FileName property cannot be set to an empty string!");
//                }
//            }
//        }

//        /// <summary>
//        /// Set name of gridND point attributes. Default set to Values.
//        /// </summary>
//        [Description("Set name of gridND point attributes. Default set to \"Values\"")]
//        public string PointAttributeName
//        {
//            set
//            {
//                if (value == string.Empty)
//                {
//                    throw new MveException(this, "Attribut property cannot be set to an empty string!");
//                }
//                else
//                {
//                    pointAttributName = value;
//                    paramsChanged = true;
//                }
//            }

//            get { return pointAttributName; }
//        }

//        #endregion
//    }
//}
