//using System;
//using System.Text;
//using System.Text.RegularExpressions;
//using Zcu.Mve.Numerics;
//using Zcu.Mve.Strings;
//using Zcu.Mve.Visualization;

//namespace Zcu.Mve.Visualization.Loaders
//{
//    /// <summary>
//    /// Parse inforamtion from .vif file, such as header size, resolution, correct-position, correct-rotation etc.
//    /// </summary>
//    internal class Vif
//    {
//        /// <summary>
//        /// Caption
//        /// </summary>
//        private MveString caption;

//        /// <summary>
//        /// Source
//        /// </summary>
//        private MveString source;

//        /// <summary>
//        /// Size of header in byte.
//        /// </summary>
//        private int headerSize;

//        /// <summary>
//        /// Bytes pex voxel.
//        /// </summary>
//        private short bytesPerVoxel;

//        /// <summary>
//        /// Signed volume data or unsigned.
//        /// </summary>
//        private bool signed;

//        /// <summary>
//        /// Byte order file.
//        /// </summary>
//        private string byteOrderFile;

//        /// <summary>
//        /// Resolution in axes.
//        /// </summary>
//        private Point3D resolution;

//        /// <summary>
//        /// Correct position.
//        /// </summary>
//        private Point3D position;

//        /// <summary>
//        /// Correct rotation.
//        /// </summary>
//        private Point3D rotation;

//        /// <summary>
//        /// Distortion of volume data.
//        /// </summary>
//        private Point3D distortion;

//        private enum Blocks { Resolution, Position, Rotation, Distortion };

//        /// <summary>
//        /// Parse .vif file. Vif contain important information about .vol file.
//        /// </summary>
//        /// <paramsChanged name="contentOfFile">whole .vol file as string</paramsChanged>
//        /// <paramsChanged name="fileName">.vol file name</paramsChanged>
//        public Vif(string contentOfFile, string fileName)
//        {
//            System.Threading.Thread.CurrentThread.CurrentCulture = System.Globalization.CultureInfo.InvariantCulture;

//            // first look for [Main] section
//            Match match = Regex.Match(contentOfFile, @"\[Main\]", RegexOptions.IgnoreCase);

//            if (!match.Success) // main section not found
//                throw new FormatException(string.Format("File {0} not contain section [Main].", fileName));

//            // start index of main section
//            int startIndex = match.Index + match.Length;
//            match = Regex.Match(contentOfFile, @"\[Resolution\]", RegexOptions.IgnoreCase);

//            if (!match.Success) // resolution section not found
//                throw new FormatException(string.Format("File {0} not contain section [Resolution].", fileName));

//            // main section
//            ParseMainBlock(contentOfFile.Substring(startIndex, match.Index - startIndex));

//            startIndex = match.Index + match.Length;
//            match = Regex.Match(contentOfFile, @"\[Correction - position\]", RegexOptions.IgnoreCase);

//            if (!match.Success) // correction - position not found
//                throw new FormatException(string.Format("File {0} not contain section [Correction - position].", fileName));

//            // resolution section
//            ParseOtherBlocks(contentOfFile.Substring(startIndex, match.Index - startIndex), Blocks.Resolution);

//            startIndex = match.Index + match.Length;
//            match = Regex.Match(contentOfFile, @"\[Correction - rotation\]", RegexOptions.IgnoreCase);

//            if (!match.Success) // correction - rotation not found
//                throw new FormatException(string.Format("File {0} not contain section [Correction - rotation].", fileName));

//            // position section
//            ParseOtherBlocks(contentOfFile.Substring(startIndex, match.Index - startIndex), Blocks.Position);

//            startIndex = match.Index + match.Length;
//            match = Regex.Match(contentOfFile, @"\[Distortion\]", RegexOptions.IgnoreCase);

//            if (!match.Success) // distortion not found
//                throw new FormatException(string.Format("File {0} not contain section [Distortion].", fileName));

//            // rotation section
//            ParseOtherBlocks(contentOfFile.Substring(startIndex, match.Index - startIndex), Blocks.Rotation);

//            // distortion section
//            ParseOtherBlocks(contentOfFile.Substring(match.Index, contentOfFile.Length - match.Index), Blocks.Distortion);
//        }

//        #region Parsing

//        /// <summary>
//        /// Parse information from main section.
//        /// </summary>
//        /// <paramsChanged name="block">content of main section to parse</paramsChanged>
//        /// <remarks>
//        /// Format of [Main] block.
//        /// [Main]
//        ///
//        /// Caption = 
//        /// Source = vol
//        /// Header Size = 38
//        /// Bytes per voxel = 1
//        /// Signed = no
//        /// Byte order file = file 
//        /// 
//        /// </remarks>
//        private void ParseMainBlock(string block)
//        {
//            string[] lines = Regex.Split(block, @"\r\n|\r|\n", RegexOptions.IgnorePatternWhitespace);
//            int index = -1;

//            if (lines.Length < 8)
//                throw new FormatException("Bad syntax of [Main] block");

//            for (int i = 2; i < 8; i++)
//            {
//                index = lines[i].IndexOf('=', 0); // starting index of search value

//                if (index != -1 && (index + 1) < lines[i].Length)
//                    switch (i)
//                    {
//                        case 2:
//                            caption = lines[i].Substring(index + 1, lines[i].Length - (index + 1)).Trim();
//                            break;

//                        case 3:
//                            source = lines[i].Substring(index + 1, lines[i].Length - (index + 1)).Trim();
//                            break;

//                        case 4:
//                            headerSize = int.Parse(lines[i].Substring(index + 1, lines[i].Length - (index + 1)).Trim());
//                            break;

//                        case 5:
//                            bytesPerVoxel = short.Parse(lines[i].Substring(index + 1, lines[i].Length - (index + 1)).Trim());
//                            break;

//                        case 6:
//                            string helper = lines[i].Substring(index + 1, lines[i].Length - (index + 1)).Trim();

//                            if (helper.ToLower() == "no")
//                                signed = false;

//                            if (helper.ToLower() == "yes")
//                                signed = true;
//                            break;

//                        case 7:
//                            byteOrderFile = lines[i].Substring(index + 1, lines[i].Length - (index + 1)).Trim();
//                            break;
//                    }
//            }
//        }

//        /// <summary>
//        /// Parse information from resolution, position, rotation and distortion sections.
//        /// </summary>
//        /// <paramsChanged name="block">content of appropriate section</paramsChanged>
//        /// <paramsChanged name="blocks">section identifier</paramsChanged>
//        private void ParseOtherBlocks(string block, Blocks blocks)
//        {
//            string[] lines = Regex.Split(block, @"\r\n|\r|\n", RegexOptions.IgnorePatternWhitespace);

//            if (lines.Length < 5)
//                throw new FormatException(string.Format("Bad syntax of [{0}] block", blocks));

//            string[] arr = new string[3]; // each section has 3 values (x = .., y = ..., z = ...)

//            int index = -1;

//            for (int i = 2; i < 5; i++)
//            {
//                index = lines[i].IndexOf('=', 0);

//                if (index != -1 && (index + 1) < lines[i].Length)
//                    switch (i)
//                    {
//                        case 2:
//                            arr[0] = lines[i].Substring(index + 1, lines[i].Length - (index + 1)).Trim();
//                            break;

//                        case 3:
//                            arr[1] = lines[i].Substring(index + 1, lines[i].Length - (index + 1)).Trim();
//                            break;

//                        case 4:
//                            arr[2] = lines[i].Substring(index + 1, lines[i].Length - (index + 1)).Trim();
//                            break;
//                    }
//            }

//            // fill exist structures
//            switch (blocks)
//            {
//                case Blocks.Resolution:
//                    resolution = new Vector3D();
//                    resolution[0] = int.Parse(arr[0]);
//                    resolution[1] = int.Parse(arr[1]);
//                    resolution[2] = int.Parse(arr[2]);
//                    break;

//                case Blocks.Position:
//                    position = new Vector3D();
//                    position[0] = float.Parse(arr[0]);
//                    position[1] = float.Parse(arr[1]);
//                    position[2] = float.Parse(arr[2]);
//                    break;

//                case Blocks.Rotation:
//                    rotation = new Vector3D();
//                    rotation[0] = float.Parse(arr[0]);
//                    rotation[1] = float.Parse(arr[1]);
//                    rotation[2] = float.Parse(arr[2]);
//                    break;

//                case Blocks.Distortion:
//                    distortion = new Vector3D();
//                    distortion[0] = float.Parse(arr[0]);
//                    distortion[1] = float.Parse(arr[1]);
//                    distortion[2] = float.Parse(arr[2]);
//                    break;
//            }
//        }

//        #endregion

//        #region Properties

//        /// <summary>
//        /// Get caption of *.vif file.
//        /// </summary>
//        public MveString Caption
//        {
//            get { return caption; }
//        }

//        /// <summary>
//        /// Get source of .vif file.
//        /// </summary>
//        public MveString Source
//        {
//            get { return source; }
//        }

//        /// <summary>
//        /// Get header size in bytes.
//        /// </summary>
//        public int HeaderSize
//        {
//            get { return headerSize; }
//        }

//        /// <summary>
//        /// Get byte per voxel.
//        /// </summary>
//        public short BytesPerVoxel
//        {
//            get { return bytesPerVoxel; }
//        }

//        /// <summary>
//        /// Define whether vol. data are signed or unsigned.
//        /// </summary>
//        public bool Signed
//        {
//            get { return signed; }
//        }

//        /// <summary>
//        /// Get vol. data resolution.
//        /// </summary>
//        public Point3D Resolution
//        {
//            get { return resolution; }
//        }

//        /// <summary>
//        /// Get vol. data correct position.
//        /// </summary>
//        public Point3D Position
//        {
//            get { return position; }
//        }

//        /// <summary>
//        /// Get vol. data correct rotation.
//        /// </summary>
//        public Point3D Rotation
//        {
//            get { return rotation; }
//        }

//        /// <summary>
//        /// Distortion of vol. data.
//        /// </summary>
//        public Point3D Distortion
//        {
//            get { return distortion; }
//        }

//        #endregion
//    }
//}
